
#define concat2(X,Y)	X##Y

#define genPORT(X)	concat2(PORT, X)
#define genPIN(X)	concat2(PIN, X)
#define genDDR(X)	concat2(DDR, X)
#define genPCMSK(X)	concat2(PCMSK, X)
#define genPCIE(X)	concat2(PCIE, X)

#define sbi(PORT, BIT) (PORT |=  _BV(BIT))
#define cbi(PORT, BIT) (PORT &= ~_BV(BIT))

#define sbiPORT_(PORT, BIT) (sbi(genPORT(PORT), BIT))
#define cbiPORT_(PORT, BIT) (cbi(genPORT(PORT), BIT))
#define sbiPIN_(PORT, BIT) (sbi(genPIN(PORT), BIT))
#define cbiPIN_(PORT, BIT) (cbi(genPIN(PORT), BIT))
#define sbiDDR_(PORT, BIT) (sbi(genDDR(PORT), BIT))
#define cbiDDR_(PORT, BIT) (cbi(genDDR(PORT), BIT))
#define sbiPCMSK_(PORT, BIT) (sbi(genPCMSK(PORT), BIT))
#define cbiPCMSK_(PORT, BIT) (cbi(genPCMSK(PORT), BIT))
#define sbiPCICR_(PORT, BIT) (sbi(PCICR, genPCIE(PORT)))
#define cbiPCICR_(PORT, BIT) (cbi(PCICR, genPCIE(PORT)))

#define sbiPORT(X)	sbiPORT_(X)
#define cbiPORT(X)	cbiPORT_(X)
#define sbiPIN(X)	sbiPIN_(X)
#define cbiPIN(X)	cbiPIN_(X)
#define sbiDDR(X)	sbiDDR_(X)
#define cbiDDR(X)	cbiDDR_(X)
#define sbiPCMSK(X)	sbiPCMSK_(X)
#define cbiPCMSK(X)	cbiPCMSK_(X)
#define sbiPCICR(X)	sbiPCICR_(X)
#define cbiPCICR(X)	cbiPCICR_(X)

#define tostr(X) #X

#define setPORT_(PORT, BIT, VALUE) ((VALUE) ? sbiPORT_(PORT, BIT) : cbiPORT_(PORT,BIT))
#define getPIN_(PORT, BIT) (genPIN(PORT) & _BV(BIT))

#define setPORT(X,Y) setPORT_(X,Y)
#define getPIN(X) getPIN_(X)
